summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJason Zaman <perfinion@gentoo.org>2019-02-01 14:45:20 +0800
committerJason Zaman <perfinion@gentoo.org>2019-02-01 20:09:01 +0800
commit3355c0462981c43e64e552c278e9adc50a6990e5 (patch)
treebab12b8f0b6c9bbf66006be9a558f729c35c4de0 /sci-libs
parentnet-libs/google-cloud-cpp: bump to 0.5.0 (diff)
downloadgentoo-3355c0462981c43e64e552c278e9adc50a6990e5.tar.gz
gentoo-3355c0462981c43e64e552c278e9adc50a6990e5.tar.bz2
gentoo-3355c0462981c43e64e552c278e9adc50a6990e5.zip
sci-libs/tensorflow: bump to 1.13.0_rc0
Signed-off-by: Jason Zaman <perfinion@gentoo.org> Package-Manager: Portage-2.3.51, Repoman-2.3.11
Diffstat (limited to 'sci-libs')
-rw-r--r--sci-libs/tensorflow/Manifest8
-rw-r--r--sci-libs/tensorflow/tensorflow-1.13.0_rc0.ebuild312
2 files changed, 320 insertions, 0 deletions
diff --git a/sci-libs/tensorflow/Manifest b/sci-libs/tensorflow/Manifest
index 818352b5d27..a2721cca8ec 100644
--- a/sci-libs/tensorflow/Manifest
+++ b/sci-libs/tensorflow/Manifest
@@ -1,13 +1,17 @@
DIST ARM_NEON_2_x86_SSE-0f77d9d182265259b135dad949230ecbf1a2633d.tar.gz 99753 BLAKE2B 79b0c9e2f3a8de91bb042e55cbc9f589970add4c9bdccd96c9a0f38887418c97aa67fc433b4feffb92a1384039b0d68a7cc6cda141371427a310172422bd41d6 SHA512 a21df040a5b3f67d9be006ae414113fa1ca86d38fa446acfab18afcbbb89ee7c48776fac5565d0694c99f1ff6ead3b10a9915eac7aae4d2a532ef5ac126a0072
+DIST ARM_NEON_2_x86_SSE-1200fe90bb174a6224a525ee60148671a786a71f.tar.gz 100612 BLAKE2B 84f81072d3298dde613b4c1ebabf852c67e04b5882a4ca0ed6f218b42e8fa3ea9598140b0c0009e8d6b62d08902622a6d57ee005ec3ad8a808c9fb21aa53430c SHA512 03a289d8099a5c4a5298cba8f516d2edb41220935d8db750970113ca7513372c78241c2c948d0ffcd60e84686e50ba1d7fd0b46efea6881dd320435eca92a7b9
+DIST abseil-cpp-389ec3f906f018661a5308458d623d01f96d7b23.tar.gz 1180190 BLAKE2B beec1338bf8cfa99d0de3bdb1631da5385317e68bf87f5da154ceab9455af7221f140838e41f4087d7d0064c22f93dce5860c484a8e4026b46efa103a52db307 SHA512 20d2cc8d23eb729607692d861049dccbd6b4af56fc4ed7733492348e3fe879d7acc6316f0d6e1c683f98188f028d460a40cab35667856cf334aa5f00fc830911
DIST abseil-cpp-48cd2c3f351ff188bc85684b84a91b6e6d17d896.tar.gz 1181139 BLAKE2B 06b4f2ab1aa8847d7d885e62d0fdbcbb559e9b8b8d0d336a51d75db26354eb95649a684921afadf49cda021bb8d7c7efc3fc33a1bbc74e06267cb13727bb8833 SHA512 6ed7345f05b09da0b51616f2aaa578873002394519e037489f8b6621ff580bf5291cd2870f3fa7b5bcc4f9c4b79f0ebbddd52469abbb619f93c08ddf0fb84e15
DIST abseil-cpp-9613678332c976568272c8f4a78631a29159271d.tar.gz 875263 BLAKE2B f11af5582ef3e00155361de2185b703fc9edde1b6cbefce62224da7b13e1beae219076f144b7b8d4bf63d1b21a73beb77fbb437e6d91e6d59a233846d91c1a99 SHA512 a3694d4c74f542f7a55872707548469e1bdc6dcd05d40ffd62de41d7440dc1fb98d260f690a6799ad39142e35226b04aacc6122aa1edf104fc9d396997995a8c
DIST abseil-cpp-f0f15c2778b0e4959244dd25e63f445a455870f5.tar.gz 1025885 BLAKE2B aa8c79912d94b67a23f42e1f2de387e8493fdff32b79ea5e958fd5b44bc2a8c804170a251d8166c4f01fd883f20962a437822b2bdd5ec614161491487833bdfc SHA512 54b664528f754f6c76888599d3a7069a7284b5dc17a31442a52faa9d3fdca23cbe3e4c1628d79c95c483f4ce6058e4d874e27ea4f859b9cafb8bb192e5093670
DIST abseil-py-0.2.2.tar.gz 189357 BLAKE2B b53976b50f1738d671a32df2fabf197785cb4be1f68dbf7f0bdd5bbbb1a73439646f5b6a9ea42d5df40debdbb8e8c72c554f428a948f3117dba5d6a8e2b473f2 SHA512 d2a393e78acc9ac28fc9b1129c23de9c2ab6059a7527eaa29e4182356b16cbce1fede94af2a8b51af9d1c606b162d8ae84eb3036ced784a89d4f7547bfce73ed
DIST backports.weakref-1.0rc1.tar.gz 7761 BLAKE2B 4cb2554a4b71bb1f8c41a790268511e4b382effc7e0328f74346d086de539a177111de9e2dabac19a44b2a1cdbf59a7425e30eee4caa4bfe66b0ca97f1f460a9 SHA512 f37e9eb0d9060d2e1588a941f623460bd4477d7e180b38b5cd46d9c1db1ee094ae63e4f5eeeb422823bf3d067f46c4124cb124a9e4ddb795bc0bfbc4802ab826
+DIST bazel-toolchains-3f8c58fe530fedc446de04673bc1e32985887dea.tar.gz 416360 BLAKE2B 4d7960302cb70247f8166647b991d74aa0514d218c9de4c97fe267ecb789e9966cfd8e546fe11661c92034df7a8de72596c5c5ddea10d145d6783cdc5aba2f9b SHA512 9a810b0a70f81fe3b9a1f23b2d171bbe723f7a33374b2caf7ce398572965f21b9de00791122c32b36e68a572b1b8982be378730f1c9f22bc375ae5f5c1c32873
DIST bazelbuild-rules_closure-dbb96841cc0a5fb2664c37822803b06dab20c7d1.tar.gz 435984 BLAKE2B 1ec325861e5e5292b2153119beff3b3be743b4833adf3571eab1a066fef06a61131ef0a761e6f8ba4bf978e7c1c073f197f48a507cd1259ee346d4209129211d SHA512 13991822624e5bdcc2424299acb1b9ce12880f46ebbf2065d7d19a66c77f1a6802862a7ea96334fc91a1c85cff516fd32a493320f0a4d98f19e9d33e5f887986
DIST boringssl-a0fb951d2a26a8ee746b52f3ba81ab011a0af778.tar.gz 22702000 BLAKE2B d54e52832ea2655590ee6d3c9063f684cd1ac1efacc6e6c60fe3177f799eaae6cf3d6fbb1a616e98514dd0bdc84ee35731bd9e285b5cd7a91a19b9493f694582 SHA512 879a48626fb58263d117f8a8b1c5b69fa99e1f06e71d5321620b16c107011c1f22d3e3443b5ad6a908ca139fcc55bdfc36fb80e884fe4490fc4dd982b668f128
DIST cub-1.8.0.zip 602396 BLAKE2B a5e302a52e04f85ae8e1836c59e799532a8b961a8d10c08fe1241c9045f88e31f1ebda6d26124b85c6df40968e1c7b3985a39961bf7614535aafcab2da1a576a SHA512 6167c5be94989f88e05a07508cf69cf2c6b22a5ac733804043daa46bd86a44a15a758b1ffb811bab28b82039d027516ed85b3d9f7677a740a7e00ec9c2f81aed
DIST double-conversion-3992066a95b823efc8ccc1baf82a1cfc73f6e9b8.zip 7071029 BLAKE2B 722c190c941b169a3292ce2141c59b8eb1bcc5edd2ed09669592dddb9354e4c6c094dafe02e5a154f215aec776f9f7cebae36b9b0317b10b707282b1ca9449a5 SHA512 1db0d4805c80e9a08d9a581051d8708ddbfe1d74fd820dccde2c2405c45c06a861bd5b535b25d191cd01064e268f3fe71e58bef16fd39471812aea6c2f97da43
+DIST eigen-9f48e814419e.tar.gz 2430237 BLAKE2B 2d9df1a23ae049e57366fa6838ee8d4b3cecf2d859ec5ffa07bf18878976a2bd99d7dd94bb08f484a8941b5cf8ac091f837a533f081232c70a45ee0583143ba3 SHA512 ee6d8773d910dbf6798cb849ef7611f0f7aaef9ed68216e91c65bd996b8a92b6c107454f6d8599d83bfa6dede7144c83924de8479a9138c7b456b086cd527ebf
DIST eigen-fd6845384b86.tar.gz 2312810 BLAKE2B aae02b053e9b22b0c063d1173b28fd7d71cdec6b6e6702624b8fdeb707ada24e5415079f1a1c7b8fe108c7e632c6c736e13cfbdc101270742565b7045a57616a SHA512 b999e60236abf7a6a5062aa55b0aeefe9254b204416092649d4a88d42fef7c571e3ba563bbbf94033093f789511793d614c1ce94a0a0f3eb4b18df466b6345a5
DIST farmhash-816a4ae622e964763ca0862d9dbd19324a1eaf45.tar.gz 467122 BLAKE2B 8b9dd426f4b9f732df6c8c09d868d1b1cc006c395b1525c46ea91c75318b723358c8e64bb0d86a73aace2032eded93f0d80cc7c2c77fddd6a39e3402ab4f2cb7 SHA512 7f5110514a8cdc7ce48d33fd94ad67d96a24e42e11b203e4d0986f4190545f051b2a63f8e09f2ac38c3aa4a5c62d9a0e02cd8ce02045037381fb62a99f0dcd00
DIST flatbuffers-1.9.0.tar.gz 681752 BLAKE2B 7886895f79ad5b8b62c4acb479d60a6fe16226a1a9daadf2c457189b7a3381676ba9dd3f8e2af5ebd5f2d78c6ac37d9d83de88ee08b566fd4e4507ecdb887938 SHA512 0ba07dbe5b2fde1d0a6e14ee26ee2816062541d934eda204b846a30c019362f2626761b628c900293928b9b546dba8ca477c13182e022c3e0e0a142fd67f0696
@@ -21,12 +25,16 @@ DIST jemalloc-4.4.0.tar.gz 444180 BLAKE2B fde0ce34e56deab10e01387aeeb3ec1c5c01a2
DIST llvm-bd8c8d759852871609ba2e4e79868420f751949d.tar.gz 42053858 BLAKE2B d8f1e7728eeb7aa7e2eaf8456088b54aa29dbcdf9635823dff4501ec5d1c382d74c8dacfcfc89aed9c42d754a757c755bdd11a5b7be213bebbe4349f972165bc SHA512 470499b7f70a4fe8f4399f74b3e02aa511bf4786ee36fd8d28459e1d426761e110dede19c3786adb824e8d4d49386e27b5a01e752bb1c39e4df294ed71771404
DIST nsync-1.20.1.tar.gz 154106 BLAKE2B 94eeb647de2ca58a3f3837119ef30805f0a72a9d12c19aa705f815955723ddefa1de4d2a3fe5fd0b227ffdd70d5208ab9a300e40b2aff2591a1cef28c79b450a SHA512 d7b9be1052b7d11d896d3fade822f7b1eebbd0a772c9f6e2cd827921f1adc29ed18f7587ebc7d29623d230be384a7a2356c1da3abd53567fc934979d89c70e0c
DIST nvidia-nccl-03d856977ecbaac87e598c0c4bafca96761b9ac7.tar.gz 47849 BLAKE2B fb2a6fc1e45057c4150c1dae2a5058a12d8641b3f5dfdd982661b4351ec9df39ac3aefaf4dfa9c8606ddf7fd1c4a8b35683e5e5eddd74cbc63ee025b33d4b731 SHA512 eb555030e9d60d68c4094e85f16e0b74de7f61602c742d57bc2029d12c719084a2fd1214c13467ff262f6f3932508754159af5f014e6f16d279d14e1fafa9b8a
+DIST nvidia-nccl-f93fe9bfd94884cec2ba711897222e0df5569a53.tar.gz 95617 BLAKE2B 023788db444b1a50f01ab16f126c920f530a6ff5bf2a9327626db45f985b4093c1024d16d43cdee9f0b3ee5c8b7d104f2a6b1dab0460c6b1998b42a0354f6f27 SHA512 d6b4dd4d6c7c9ca2dcf0699055c9193d4b46c0c5155e0108db38094577c92f954f604b2e83ca320873288e0010eaa3c5812f05f7fafe5112bebbca78e56cb279
DIST oourafft-20061228.tgz 72213 BLAKE2B 4a3ac2b4c0bc3275b5743df59241e1cdbd0200371c153ddf54ef6c7c4ec523ee6560547e2d5ef9f3200037c0635bf41c18991ac35f271b1e600d0dbd65d1a9a7 SHA512 f1ceac00cb7b9eb8f625eee7f1f5eea8af363343589a344226628d68baf668c176e6c23b7f904c4e682330352eaa0cd5d00731340d208e94c9657b8f85ae2240
DIST protobuf-3.6.0.tar.gz 4483224 BLAKE2B b6716d33c14ab98a05676a3369b4762179df88ed3e8c34b93075c12edc10213bf1c427a59a8840bc64b53365264021b8075a02a44478c998062cf04da95c0075 SHA512 46df0187e5c9e7d213930d916f6c89e7a41eca1aaac228d8f56e3f784598a9f323d7cc2d3cf20668ceb776d3237c4eccf685ef8d7808f09107fa8e441f9899f4
+DIST rules_docker-a9bb1dab84cdf46e34d1b34b53a17bda129b5eba.tar.gz 446437 BLAKE2B 070e1028625c74e6fbd092a3f8c6cf6de3b98d8999fdd69527674cfc55f00bd7638f7cb1eba41d496d1de3307b81b9dfd832d7d4bc65f9d98cd53714cb24bb02 SHA512 e43c013027a7235e85c263d8cfc40f9af77f54d054665116bb8641ed7f60d077b9107aa97da5b7e102077b68be7d2cbe401091016bd46f8828ae159659ce9608
DIST tensorflow-1.10.0.tar.gz 24490786 BLAKE2B 2ecec19b2b2ebb2e292ec07fee458017aa3fcc4c1445e6c9419ea9bd37990a58607c8f3134c785be0e3ae098c332a734fb85717b2ecd781551a0c8f20ffca8f2 SHA512 a25257ad7e561c2040ba9dda699acb24b757e6d79c60324cab20d8d8a428fef79a06a3627a95a59e2c8408a094666b9aa6d8af1c5419fa8c238e1f5e10e9ec33
DIST tensorflow-1.11.0.tar.gz 25024790 BLAKE2B 74129fb1e6db0317fd45266dae7aa4fab811e1ebf0d093f3153684fa4465f4319cbf8fd50c6667f9c4ddbce5c100ee00151ec2873eca93ef7d5ebbc04ab6b965 SHA512 26e9542c43e11a663cbc5cf42859ae7b6dc0e92cfa88775fd4d1badba7f08c59b60c05010fd9f3ec501313be5c042f39b17323bb4753babf365ba2a48af836c2
DIST tensorflow-1.12.0.tar.gz 26341737 BLAKE2B 6b9e21a9367ec7454916af327ae21fc6c46e54885f30823784985a61193654fd1942cbd3b5688f55cbd63f890417eac812d0cdb576d0f0b8677df92c259837c0 SHA512 b145a9118856aa00a829ab6af89bff4e1e131371c96d77b07532544112803c4574d97ef224b28a64437a2af8db4286786dc0b4123efe110b2aa734b443a7e238
+DIST tensorflow-1.13.0_rc0.tar.gz 31616223 BLAKE2B b4cb76cdb0e79639e8a1282835101d8a5e23a0e9d659dfbc01d8395528d05c434d0cc93df010086acbc338590d8ced3d95b4b00d6e1a7ebbe8d1df1f87265114 SHA512 0d8f88a8882ae1f69eee82fd54a836b3a0629c6a274af8ef329421445aeb446b651b90285c3ea19cb768860fd759e715dea481d5a07ec722ebd34323331e61dd
DIST tensorflow-patches-1.10.0.tar.bz2 4032 BLAKE2B 8588deec74179d8044af631de8e651491cc713553ee15ece9dff5052bd95b10924bdbe4301453f00d0f2fccd5d595d496b48fe45b0259837653b2de9e1898ab9 SHA512 1f57995ca9b3278735636cc42c88dc45558fa6a1d656108293f8df3fd9961d75f5e979bf0a9909136134e1cdaab41a34f83e605b48b23dddf17a6b1be684117b
DIST tensorflow-patches-1.11.0.tar.bz2 11013 BLAKE2B 929cb9fee5e6b63f00341351908d3050c676670d9cc2c1241bd2e3c86601704a7495ab598b992718f0b51fc369e33e7c646bc5db3ba3b86b18326b1c2d2974a8 SHA512 76a94c9444e1d984afaf080222d430032636204d05a5e3ff5530012dfa1eba78619dd2a2942343ccc2f7fc489eb8c6f51fddd0b84cb2c2db645b2b914cc61f80
DIST tensorflow-patches-1.12.0.tar.bz2 10638 BLAKE2B fc2c30f6b425390f5791df8ec409165aa4cc242eb93885845cc34e8302f781b267efaebf9e996f0cbc7558d975d742fb2e5509df9f06d85a370ea73795f92c49 SHA512 2b734e206eda58c898ad7090b3fe371b08c06dcb52d07fc0991548cec7e45c2500e797dd7b98b8a3a4416b85c8886314bd75921d0cd6d942a7cd15688954dd5d
+DIST tensorflow-python-license.rst.txt 45132 BLAKE2B 770ddd87adc745a021daac01a284131825a33f176002a28b20a2251246183bf7ab4686305620678285e4a216a37f01b3ad953fe7864fa79611cccde156d69ab6 SHA512 2d5a3783ec340f24797e89c78007ee95ab753eb5ee8198c739544f9e1159895f7abe816d6b3c66620f8d7b64641d2a7f44ff0a5b4f2f941928f4733157c7995e
DIST tensorflow-python-license.txt 45132 BLAKE2B 1f572a06eeb4a58a5563b87a2db381a6e9eb0195cf1d006bda0d3da158e62a1e67e889a7d3d0da83d8609c0d048887bcbbd0d7056fd8e4f56b654047f36936fa SHA512 1b8c2f9733fcf27d560879418c366b5c3e44420d42adb3b857ee741793ddc75ad18324b016909457e5311f2143593392ce4404d12962f076e62f6036afbb521e
diff --git a/sci-libs/tensorflow/tensorflow-1.13.0_rc0.ebuild b/sci-libs/tensorflow/tensorflow-1.13.0_rc0.ebuild
new file mode 100644
index 00000000000..580a80f6a9c
--- /dev/null
+++ b/sci-libs/tensorflow/tensorflow-1.13.0_rc0.ebuild
@@ -0,0 +1,312 @@
+# Copyright 1999-2019 Jason Zaman
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+DISTUTILS_OPTIONAL=1
+PYTHON_COMPAT=( python2_7 python{3_5,3_6} )
+MY_PV=${PV/_rc/-rc}
+MY_P=${PN}-${MY_PV}
+
+inherit bazel check-reqs cuda distutils-r1 flag-o-matic toolchain-funcs
+
+DESCRIPTION="Computation framework using data flow graphs for scalable machine learning"
+HOMEPAGE="https://www.tensorflow.org/"
+
+LICENSE="Apache-2.0"
+SLOT="0"
+KEYWORDS="~amd64"
+IUSE="cuda mpi +python"
+CPU_USE_FLAGS_X86="sse sse2 sse3 sse4_1 sse4_2 avx avx2 fma3 fma4"
+for i in $CPU_USE_FLAGS_X86; do
+ IUSE+=" cpu_flags_x86_$i"
+done
+
+# distfiles that bazel uses for the workspace, will be copied to basel-distdir
+bazel_external_uris="
+ http://www.kurims.kyoto-u.ac.jp/~ooura/fft.tgz -> oourafft-20061228.tgz
+ https://bitbucket.org/eigen/eigen/get/9f48e814419e.tar.gz -> eigen-9f48e814419e.tar.gz
+ https://github.com/abseil/abseil-cpp/archive/389ec3f906f018661a5308458d623d01f96d7b23.tar.gz -> abseil-cpp-389ec3f906f018661a5308458d623d01f96d7b23.tar.gz
+ https://github.com/bazelbuild/rules_closure/archive/dbb96841cc0a5fb2664c37822803b06dab20c7d1.tar.gz -> bazelbuild-rules_closure-dbb96841cc0a5fb2664c37822803b06dab20c7d1.tar.gz
+ https://github.com/bazelbuild/rules_docker/archive/a9bb1dab84cdf46e34d1b34b53a17bda129b5eba.tar.gz -> rules_docker-a9bb1dab84cdf46e34d1b34b53a17bda129b5eba.tar.gz
+ https://github.com/google/double-conversion/archive/3992066a95b823efc8ccc1baf82a1cfc73f6e9b8.zip -> double-conversion-3992066a95b823efc8ccc1baf82a1cfc73f6e9b8.zip
+ https://github.com/google/farmhash/archive/816a4ae622e964763ca0862d9dbd19324a1eaf45.tar.gz -> farmhash-816a4ae622e964763ca0862d9dbd19324a1eaf45.tar.gz
+ https://github.com/google/gemmlowp/archive/38ebac7b059e84692f53e5938f97a9943c120d98.zip -> gemmlowp-38ebac7b059e84692f53e5938f97a9943c120d98.zip
+ https://github.com/google/highwayhash/archive/fd3d9af80465e4383162e4a7c5e2f406e82dd968.tar.gz -> highwayhash-fd3d9af80465e4383162e4a7c5e2f406e82dd968.tar.gz
+ https://github.com/nlopezgi/bazel-toolchains/archive/3f8c58fe530fedc446de04673bc1e32985887dea.tar.gz -> bazel-toolchains-3f8c58fe530fedc446de04673bc1e32985887dea.tar.gz
+ cuda? (
+ https://github.com/nvidia/nccl/archive/f93fe9bfd94884cec2ba711897222e0df5569a53.tar.gz -> nvidia-nccl-f93fe9bfd94884cec2ba711897222e0df5569a53.tar.gz
+ https://github.com/NVlabs/cub/archive/1.8.0.zip -> cub-1.8.0.zip
+ )
+ python? (
+ https://github.com/intel/ARM_NEON_2_x86_SSE/archive/1200fe90bb174a6224a525ee60148671a786a71f.tar.gz -> ARM_NEON_2_x86_SSE-1200fe90bb174a6224a525ee60148671a786a71f.tar.gz
+ https://mirror.bazel.build/docs.python.org/2.7/_sources/license.rst.txt -> tensorflow-python-license.rst.txt
+ https://pypi.python.org/packages/bc/cc/3cdb0a02e7e96f6c70bd971bc8a90b8463fda83e264fa9c5c1c98ceabd81/backports.weakref-1.0rc1.tar.gz
+ )"
+
+#https://dev.gentoo.org/~perfinion/patches/tensorflow-patches-${PV}.tar.bz2
+SRC_URI="https://github.com/${PN}/${PN}/archive/v${MY_PV}.tar.gz -> ${P}.tar.gz
+ ${bazel_external_uris}"
+
+RDEPEND="
+ app-arch/snappy
+ dev-db/lmdb
+ dev-db/sqlite
+ dev-libs/icu
+ >=dev-libs/jsoncpp-1.8.4
+ dev-libs/libpcre
+ dev-libs/nsync
+ dev-libs/openssl:0
+ >=dev-libs/protobuf-3.6.0
+ >=dev-libs/re2-0.2018.04.01
+ media-libs/giflib
+ media-libs/libjpeg-turbo
+ media-libs/libpng:0
+ >=net-libs/grpc-1.16.0
+ net-misc/curl
+ sys-libs/zlib
+ cuda? (
+ >=dev-util/nvidia-cuda-toolkit-8.0[profiler]
+ >=dev-libs/cudnn-6.0
+ )
+ mpi? ( virtual/mpi )
+ python? (
+ ${PYTHON_DEPS}
+ >=dev-libs/flatbuffers-1.8.0
+ dev-python/absl-py[${PYTHON_USEDEP}]
+ dev-python/astor[${PYTHON_USEDEP}]
+ dev-python/gast[${PYTHON_USEDEP}]
+ dev-python/numpy[${PYTHON_USEDEP}]
+ >=dev-python/protobuf-python-3.6.0[${PYTHON_USEDEP}]
+ dev-python/six[${PYTHON_USEDEP}]
+ dev-python/termcolor[${PYTHON_USEDEP}]
+ dev-python/grpcio[${PYTHON_USEDEP}]
+ net-libs/google-cloud-cpp
+ >=sci-libs/keras-applications-1.0.6[${PYTHON_USEDEP}]
+ >=sci-libs/keras-preprocessing-1.0.5[${PYTHON_USEDEP}]
+ >=sci-visualization/tensorboard-1.12.0[${PYTHON_USEDEP}]
+ virtual/python-enum34[${PYTHON_USEDEP}]
+ )"
+DEPEND="${RDEPEND}
+ dev-python/mock"
+BDEPEND="
+ app-arch/unzip
+ >=dev-libs/protobuf-3.6.0
+ dev-java/java-config
+ dev-python/mock
+ dev-lang/swig
+ dev-python/cython
+ cuda? (
+ >=dev-util/nvidia-cuda-toolkit-8.0[profiler]
+ )
+ !python? ( dev-lang/python )
+ python? (
+ dev-python/grpcio-tools
+ )"
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+S="${WORKDIR}/${MY_P}"
+
+DOCS=( AUTHORS CONTRIBUTING.md ISSUE_TEMPLATE.md README.md RELEASE.md )
+CHECKREQS_MEMORY="5G"
+CHECKREQS_DISK_BUILD="5G"
+
+get-cpu-flags() {
+ local i f=()
+ # Keep this list in sync with tensorflow/core/platform/cpu_feature_guard.cc.
+ for i in sse sse2 sse3 sse4_1 sse4_2 avx avx2 fma4; do
+ use cpu_flags_x86_${i} && f+=( -m${i/_/.} )
+ done
+ use cpu_flags_x86_fma3 && f+=( -mfma )
+ echo "${f[*]}"
+}
+
+pkg_setup() {
+ check-reqs_pkg_setup
+}
+
+src_unpack() {
+ # Only unpack the main distfile
+ unpack "${P}.tar.gz"
+ #unpack tensorflow-patches-${PVR}.tar.bz2
+ bazel_load_distfiles "${bazel_external_uris}"
+}
+
+src_prepare() {
+ export JAVA_HOME=$(java-config --jre-home) # so keepwork works
+
+ append-flags $(get-cpu-flags)
+ bazel_setup_bazelrc
+
+ #eapply "${WORKDIR}"/patches/*.patch
+
+ default
+ use python && python_copy_sources
+
+ use cuda && cuda_add_sandbox
+}
+
+src_configure() {
+ export JAVA_HOME=$(java-config --jre-home) # so keepwork works
+
+ do_configure() {
+ export CC_OPT_FLAGS=" "
+ export TF_ENABLE_XLA=0
+ export TF_NEED_OPENCL_SYCL=0
+ export TF_NEED_OPENCL=0
+ export TF_NEED_COMPUTECPP=0
+ export TF_NEED_ROCM=0
+ export TF_NEED_MPI=$(usex mpi 1 0)
+ export TF_SET_ANDROID_WORKSPACE=0
+
+ if use python; then
+ python_export PYTHON_SITEDIR
+ export PYTHON_BIN_PATH="${PYTHON}"
+ export PYTHON_LIB_PATH="${PYTHON_SITEDIR}"
+ else
+ export PYTHON_BIN_PATH="$(which python)"
+ export PYTHON_LIB_PATH="$(python -c 'from distutils.sysconfig import *; print(get_python_lib())')"
+ fi
+
+ export TF_NEED_CUDA=$(usex cuda 1 0)
+ export TF_DOWNLOAD_CLANG=0
+ export TF_CUDA_CLANG=0
+ export TF_NEED_TENSORRT=0
+ if use cuda; then
+ export CUDA_TOOLKIT_PATH="${EPREFIX%/}/opt/cuda"
+ export CUDNN_INSTALL_PATH="${EPREFIX%/}/opt/cuda"
+ export GCC_HOST_COMPILER_PATH="$(cuda_gccdir)/$(tc-getCC)"
+ export TF_NCCL_VERSION="1"
+ export TF_CUDA_VERSION="$(cuda_toolkit_version)"
+ export TF_CUDNN_VERSION="$(cuda_cudnn_version)"
+ einfo "Setting CUDA version: $TF_CUDA_VERSION"
+ einfo "Setting CUDNN version: $TF_CUDNN_VERSION"
+ fi
+
+ local SYSLIBS=(
+ absl_py
+ astor_archive
+ boringssl
+ com_github_googleapis_googleapis
+ com_github_googlecloudplatform_google_cloud_cpp
+ com_google_protobuf
+ com_google_protobuf_cc
+ com_googlesource_code_re2
+ curl
+ cython
+ flatbuffers
+ gast_archive
+ gif_archive
+ grpc
+ icu
+ jpeg
+ jsoncpp_git
+ keras_applications_archive
+ lmdb
+ nasm
+ nsync
+ org_sqlite
+ pcre
+ png_archive
+ protobuf_archive
+ six_archive
+ snappy
+ swig
+ termcolor_archive
+ zlib_archive
+ )
+
+ export TF_SYSTEM_LIBS="${SYSLIBS[@]}"
+
+ # This is not autoconf
+ ./configure || die
+
+ echo 'build --config=noaws --config=nohdfs --config=noignite --config=nokafka' >> .bazelrc || die
+ }
+ if use python; then
+ python_foreach_impl run_in_build_dir do_configure
+ else
+ do_configure
+ fi
+}
+
+src_compile() {
+ export JAVA_HOME=$(java-config --jre-home) # so keepwork works
+
+ if use python; then
+ python_setup
+ BUILD_DIR="${S}-${EPYTHON/./_}"
+ cd "${BUILD_DIR}"
+ fi
+
+ # fail early if any deps are missing
+ ebazel build --nobuild \
+ //tensorflow:libtensorflow_framework.so \
+ //tensorflow:libtensorflow.so \
+ //tensorflow:libtensorflow_cc.so \
+ $(usex python '//tensorflow/tools/pip_package:build_pip_package' '')
+
+ ebazel build \
+ //tensorflow:libtensorflow_framework.so \
+ //tensorflow:libtensorflow.so
+ ebazel build //tensorflow:libtensorflow_cc.so
+
+ do_compile() {
+ ebazel build //tensorflow/tools/pip_package:build_pip_package
+ }
+ BUILD_DIR="${S}"
+ cd "${BUILD_DIR}"
+ use python && python_foreach_impl run_in_build_dir do_compile
+ ebazel shutdown
+}
+
+src_install() {
+ local i j
+ export JAVA_HOME=$(java-config --jre-home) # so keepwork works
+
+ do_install() {
+ einfo "Installing ${EPYTHON} files"
+ local srcdir="${T}/src-${MULTIBUILD_VARIANT}"
+ mkdir -p "${srcdir}" || die
+ bazel-bin/tensorflow/tools/pip_package/build_pip_package --src "${srcdir}" || die
+ cd "${srcdir}" || die
+ esetup.py install
+
+ # libtensorflow_framework.so is in /usr/lib already
+ python_export PYTHON_SITEDIR PYTHON_SCRIPTDIR
+ rm -f "${D}/${PYTHON_SITEDIR}/${PN}/lib${PN}_framework.so" || die
+ python_optimize
+ }
+
+ if use python; then
+ python_foreach_impl run_in_build_dir do_install
+
+ # Symlink to python-exec scripts
+ for i in "${ED}"/usr/lib/python-exec/*/*; do
+ n="${i##*/}"
+ [[ -e "${ED}/usr/bin/${n}" ]] || dosym ../lib/python-exec/python-exec2 "/usr/bin/${n}"
+ done
+
+ python_setup
+ local BUILD_DIR="${S}-${EPYTHON/./_}"
+ cd "${BUILD_DIR}" || die
+ fi
+
+ einfo "Installing headers"
+ ebazel build //tensorflow:install_headers
+ ebazel shutdown
+ insinto /usr/include/${PN}/
+ doins -r bazel-genfiles/tensorflow/include/*
+
+ einfo "Installing libs"
+ # Generate pkg-config file
+ ${PN}/c/generate-pc.sh --prefix="${EPREFIX}"/usr --libdir=$(get_libdir) --version=${MY_PV} || die
+ insinto /usr/$(get_libdir)/pkgconfig
+ doins ${PN}.pc
+
+ dolib.so bazel-bin/tensorflow/lib${PN}_framework.so
+ dolib.so bazel-bin/tensorflow/lib${PN}.so
+ dolib.so bazel-bin/tensorflow/lib${PN}_cc.so
+
+ einstalldocs
+}